# coding: utf-8

"""
    Nucleus API

    BETA version of the nucleus text analytics API.  # noqa: E501

    OpenAPI spec version: v0.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class NucleusApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_author_connectivity_api(self, dataset, target_author, time_period, **kwargs):  # noqa: E501
        """get_author_connectivity_api  # noqa: E501

        Get the network of similar authors to a reference author.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_author_connectivity_api(dataset, target_author, time_period, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str target_author: Name of the author to be analyzed. (required)
        :param str time_period: Time period selection (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Subject covered by the author, on which to focus the analysis of connectivity. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of words possibly used by the target author that are considered not information-bearing.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: AuthorConnect
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_author_connectivity_api_with_http_info(dataset, target_author, time_period, **kwargs)  # noqa: E501
        else:
            (data) = self.get_author_connectivity_api_with_http_info(dataset, target_author, time_period, **kwargs)  # noqa: E501
            return data

    def get_author_connectivity_api_with_http_info(self, dataset, target_author, time_period, **kwargs):  # noqa: E501
        """get_author_connectivity_api  # noqa: E501

        Get the network of similar authors to a reference author.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_author_connectivity_api_with_http_info(dataset, target_author, time_period, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str target_author: Name of the author to be analyzed. (required)
        :param str time_period: Time period selection (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Subject covered by the author, on which to focus the analysis of connectivity. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of words possibly used by the target author that are considered not information-bearing.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: AuthorConnect
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'target_author', 'time_period', 'query', 'custom_stop_words', 'metadata_selection', 'excluded_docs']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_author_connectivity_api" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_author_connectivity_api`")  # noqa: E501
        # verify the required parameter 'target_author' is set
        if ('target_author' not in params or
                params['target_author'] is None):
            raise ValueError("Missing the required parameter `target_author` when calling `get_author_connectivity_api`")  # noqa: E501
        # verify the required parameter 'time_period' is set
        if ('time_period' not in params or
                params['time_period'] is None):
            raise ValueError("Missing the required parameter `time_period` when calling `get_author_connectivity_api`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'target_author' in params:
            query_params.append(('target_author', params['target_author']))  # noqa: E501
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501
        if 'custom_stop_words' in params:
            query_params.append(('custom_stop_words', params['custom_stop_words']))  # noqa: E501
        if 'time_period' in params:
            query_params.append(('time_period', params['time_period']))  # noqa: E501
        if 'metadata_selection' in params:
            query_params.append(('metadata_selection', params['metadata_selection']))  # noqa: E501
        if 'excluded_docs' in params:
            query_params.append(('excluded_docs', params['excluded_docs']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/topics/author_connectivity', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AuthorConnect',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_dataset_info(self, dataset, **kwargs):  # noqa: E501
        """get_dataset_info  # noqa: E501

        Get information about a dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dataset_info(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :return: GetDatasetInfoModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_dataset_info_with_http_info(dataset, **kwargs)  # noqa: E501
        else:
            (data) = self.get_dataset_info_with_http_info(dataset, **kwargs)  # noqa: E501
            return data

    def get_dataset_info_with_http_info(self, dataset, **kwargs):  # noqa: E501
        """get_dataset_info  # noqa: E501

        Get information about a dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_dataset_info_with_http_info(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :return: GetDatasetInfoModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'query', 'metadata_selection', 'time_period']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_dataset_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_dataset_info`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501
        if 'metadata_selection' in params:
            query_params.append(('metadata_selection', params['metadata_selection']))  # noqa: E501
        if 'time_period' in params:
            query_params.append(('time_period', params['time_period']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/datasets/dataset_info', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='GetDatasetInfoModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_doc_display(self, dataset, **kwargs):  # noqa: E501
        """get_doc_display  # noqa: E501

        Document display.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_doc_display(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str doc_titles: The title of the documents on which info is requested. Example: [ \"title 1\", \"title 2\" ] 
        :param str doc_ids: The docid of the documents on which info is requested. Example:[ \"docid1, docid2\" ]
        :return: DocDispModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_doc_display_with_http_info(dataset, **kwargs)  # noqa: E501
        else:
            (data) = self.get_doc_display_with_http_info(dataset, **kwargs)  # noqa: E501
            return data

    def get_doc_display_with_http_info(self, dataset, **kwargs):  # noqa: E501
        """get_doc_display  # noqa: E501

        Document display.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_doc_display_with_http_info(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str doc_titles: The title of the documents on which info is requested. Example: [ \"title 1\", \"title 2\" ] 
        :param str doc_ids: The docid of the documents on which info is requested. Example:[ \"docid1, docid2\" ]
        :return: DocDispModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'doc_titles', 'doc_ids']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_doc_display" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_doc_display`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'doc_titles' in params:
            query_params.append(('doc_titles', params['doc_titles']))  # noqa: E501
        if 'doc_ids' in params:
            query_params.append(('doc_ids', params['doc_ids']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/documents/document_display', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DocDispModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_doc_info(self, dataset, **kwargs):  # noqa: E501
        """get_doc_info  # noqa: E501

        Document metadata retrieval.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_doc_info(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str doc_titles: The title of the documents on which info is requested. Example: [ \"title 1\", \"title 2\" ] 
        :param str doc_ids: The docid of the documents on which info is requested. Example:[ \"docid1, docid2\" ]
        :return: DocInfoModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_doc_info_with_http_info(dataset, **kwargs)  # noqa: E501
        else:
            (data) = self.get_doc_info_with_http_info(dataset, **kwargs)  # noqa: E501
            return data

    def get_doc_info_with_http_info(self, dataset, **kwargs):  # noqa: E501
        """get_doc_info  # noqa: E501

        Document metadata retrieval.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_doc_info_with_http_info(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str doc_titles: The title of the documents on which info is requested. Example: [ \"title 1\", \"title 2\" ] 
        :param str doc_ids: The docid of the documents on which info is requested. Example:[ \"docid1, docid2\" ]
        :return: DocInfoModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'doc_titles', 'doc_ids']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_doc_info" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_doc_info`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'doc_titles' in params:
            query_params.append(('doc_titles', params['doc_titles']))  # noqa: E501
        if 'doc_ids' in params:
            query_params.append(('doc_ids', params['doc_ids']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/documents/document_info', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DocInfoModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_doc_recommend_api(self, dataset, **kwargs):  # noqa: E501
        """get_doc_recommend_api  # noqa: E501

        Recommendation of documents on given topics that have been extracted from a given dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_doc_recommend_api(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words.
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param int num_docs: Number of desired recommended docs per topic.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: DocumentRecommendModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_doc_recommend_api_with_http_info(dataset, **kwargs)  # noqa: E501
        else:
            (data) = self.get_doc_recommend_api_with_http_info(dataset, **kwargs)  # noqa: E501
            return data

    def get_doc_recommend_api_with_http_info(self, dataset, **kwargs):  # noqa: E501
        """get_doc_recommend_api  # noqa: E501

        Recommendation of documents on given topics that have been extracted from a given dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_doc_recommend_api_with_http_info(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words.
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param int num_docs: Number of desired recommended docs per topic.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: DocumentRecommendModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'query', 'custom_stop_words', 'num_topics', 'num_keywords', 'num_docs', 'metadata_selection', 'time_period', 'excluded_docs']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_doc_recommend_api" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_doc_recommend_api`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501
        if 'custom_stop_words' in params:
            query_params.append(('custom_stop_words', params['custom_stop_words']))  # noqa: E501
        if 'num_topics' in params:
            query_params.append(('num_topics', params['num_topics']))  # noqa: E501
        if 'num_keywords' in params:
            query_params.append(('num_keywords', params['num_keywords']))  # noqa: E501
        if 'num_docs' in params:
            query_params.append(('num_docs', params['num_docs']))  # noqa: E501
        if 'metadata_selection' in params:
            query_params.append(('metadata_selection', params['metadata_selection']))  # noqa: E501
        if 'time_period' in params:
            query_params.append(('time_period', params['time_period']))  # noqa: E501
        if 'excluded_docs' in params:
            query_params.append(('excluded_docs', params['excluded_docs']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/documents/document_recommend', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DocumentRecommendModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_doc_summary_api(self, dataset, doc_title, **kwargs):  # noqa: E501
        """get_doc_summary_api  # noqa: E501

        Document summarization.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_doc_summary_api(dataset, doc_title, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str doc_title: The title of the document to be summarized. (required)
        :param str custom_stop_words: List of stop words
        :param int summary_length: The maximum number of bullet points a user wants to see in the document summary.
        :param int context_amount: The number of sentences surrounding key summary sentences in the documents that they come from.
        :return: DocumentSummaryModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_doc_summary_api_with_http_info(dataset, doc_title, **kwargs)  # noqa: E501
        else:
            (data) = self.get_doc_summary_api_with_http_info(dataset, doc_title, **kwargs)  # noqa: E501
            return data

    def get_doc_summary_api_with_http_info(self, dataset, doc_title, **kwargs):  # noqa: E501
        """get_doc_summary_api  # noqa: E501

        Document summarization.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_doc_summary_api_with_http_info(dataset, doc_title, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str doc_title: The title of the document to be summarized. (required)
        :param str custom_stop_words: List of stop words
        :param int summary_length: The maximum number of bullet points a user wants to see in the document summary.
        :param int context_amount: The number of sentences surrounding key summary sentences in the documents that they come from.
        :return: DocumentSummaryModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'doc_title', 'custom_stop_words', 'summary_length', 'context_amount']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_doc_summary_api" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_doc_summary_api`")  # noqa: E501
        # verify the required parameter 'doc_title' is set
        if ('doc_title' not in params or
                params['doc_title'] is None):
            raise ValueError("Missing the required parameter `doc_title` when calling `get_doc_summary_api`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'custom_stop_words' in params:
            query_params.append(('custom_stop_words', params['custom_stop_words']))  # noqa: E501
        if 'doc_title' in params:
            query_params.append(('doc_title', params['doc_title']))  # noqa: E501
        if 'summary_length' in params:
            query_params.append(('summary_length', params['summary_length']))  # noqa: E501
        if 'context_amount' in params:
            query_params.append(('context_amount', params['context_amount']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/documents/document_summary', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DocumentSummaryModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_job(self, id, **kwargs):  # noqa: E501
        """get_job  # noqa: E501

        Use this API to check the progress and retrieve results of a job. Poll this endpoint repeatedly until result is not null.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_job(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: ID of the job (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_job_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_job_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def get_job_with_http_info(self, id, **kwargs):  # noqa: E501
        """get_job  # noqa: E501

        Use this API to check the progress and retrieve results of a job. Poll this endpoint repeatedly until result is not null.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_job_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str id: ID of the job (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_job" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `get_job`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'id' in params:
            query_params.append(('id', params['id']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/jobs', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_list_datasets(self, **kwargs):  # noqa: E501
        """get_list_datasets  # noqa: E501

        List the datasets owned by the user.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_list_datasets(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: UserDatasetModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_list_datasets_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.get_list_datasets_with_http_info(**kwargs)  # noqa: E501
            return data

    def get_list_datasets_with_http_info(self, **kwargs):  # noqa: E501
        """get_list_datasets  # noqa: E501

        List the datasets owned by the user.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_list_datasets_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :return: UserDatasetModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_list_datasets" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/datasets', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='UserDatasetModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_topic_api(self, dataset, **kwargs):  # noqa: E501
        """get_topic_api  # noqa: E501

        Get key topics from a given dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_api(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words.
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopicModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_topic_api_with_http_info(dataset, **kwargs)  # noqa: E501
        else:
            (data) = self.get_topic_api_with_http_info(dataset, **kwargs)  # noqa: E501
            return data

    def get_topic_api_with_http_info(self, dataset, **kwargs):  # noqa: E501
        """get_topic_api  # noqa: E501

        Get key topics from a given dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_api_with_http_info(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words.
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopicModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'query', 'custom_stop_words', 'num_topics', 'num_keywords', 'metadata_selection', 'time_period', 'excluded_docs']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_topic_api" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_topic_api`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501
        if 'custom_stop_words' in params:
            query_params.append(('custom_stop_words', params['custom_stop_words']))  # noqa: E501
        if 'num_topics' in params:
            query_params.append(('num_topics', params['num_topics']))  # noqa: E501
        if 'num_keywords' in params:
            query_params.append(('num_keywords', params['num_keywords']))  # noqa: E501
        if 'metadata_selection' in params:
            query_params.append(('metadata_selection', params['metadata_selection']))  # noqa: E501
        if 'time_period' in params:
            query_params.append(('time_period', params['time_period']))  # noqa: E501
        if 'excluded_docs' in params:
            query_params.append(('excluded_docs', params['excluded_docs']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/topics/topics', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TopicModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_topic_consensus_api(self, dataset, **kwargs):  # noqa: E501
        """get_topic_consensus_api  # noqa: E501

        Get topic consensus for topics extracted from a given dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_consensus_api(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopicConsensusModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_topic_consensus_api_with_http_info(dataset, **kwargs)  # noqa: E501
        else:
            (data) = self.get_topic_consensus_api_with_http_info(dataset, **kwargs)  # noqa: E501
            return data

    def get_topic_consensus_api_with_http_info(self, dataset, **kwargs):  # noqa: E501
        """get_topic_consensus_api  # noqa: E501

        Get topic consensus for topics extracted from a given dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_consensus_api_with_http_info(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopicConsensusModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'query', 'custom_stop_words', 'num_topics', 'num_keywords', 'metadata_selection', 'time_period', 'excluded_docs']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_topic_consensus_api" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_topic_consensus_api`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501
        if 'custom_stop_words' in params:
            query_params.append(('custom_stop_words', params['custom_stop_words']))  # noqa: E501
        if 'num_topics' in params:
            query_params.append(('num_topics', params['num_topics']))  # noqa: E501
        if 'num_keywords' in params:
            query_params.append(('num_keywords', params['num_keywords']))  # noqa: E501
        if 'metadata_selection' in params:
            query_params.append(('metadata_selection', params['metadata_selection']))  # noqa: E501
        if 'time_period' in params:
            query_params.append(('time_period', params['time_period']))  # noqa: E501
        if 'excluded_docs' in params:
            query_params.append(('excluded_docs', params['excluded_docs']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/topics/topic_consensus', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TopicConsensusModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_topic_delta_api(self, dataset, time_start_t0, time_end_t0, time_start_t1, time_end_t1, **kwargs):  # noqa: E501
        """get_topic_delta_api  # noqa: E501

        Get changes in exposure to key topics from documents in a dataset in between two dates.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_delta_api(dataset, time_start_t0, time_end_t0, time_start_t1, time_end_t1, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset with a time series component. These docs should reference a universe of entities that overlaps through time. (required)
        :param str time_start_t0: Start date for the start-of-period dataset. Format: \"YYYY-MM-DD HH:MM:SS\"  (required)
        :param str time_end_t0: End date for the start-of-period dataset. Format: \"YYYY-MM-DD HH:MM:SS\"  (required)
        :param str time_start_t1: Start date for the end-of-period dataset. Format: \"YYYY-MM-DD HH:MM:SS\"  (required)
        :param str time_end_t1: End date for the end-of-period dataset. Format: \"YYYY-MM-DD HH:MM:SS\"  (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words.
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopicDeltaModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_topic_delta_api_with_http_info(dataset, time_start_t0, time_end_t0, time_start_t1, time_end_t1, **kwargs)  # noqa: E501
        else:
            (data) = self.get_topic_delta_api_with_http_info(dataset, time_start_t0, time_end_t0, time_start_t1, time_end_t1, **kwargs)  # noqa: E501
            return data

    def get_topic_delta_api_with_http_info(self, dataset, time_start_t0, time_end_t0, time_start_t1, time_end_t1, **kwargs):  # noqa: E501
        """get_topic_delta_api  # noqa: E501

        Get changes in exposure to key topics from documents in a dataset in between two dates.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_delta_api_with_http_info(dataset, time_start_t0, time_end_t0, time_start_t1, time_end_t1, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset with a time series component. These docs should reference a universe of entities that overlaps through time. (required)
        :param str time_start_t0: Start date for the start-of-period dataset. Format: \"YYYY-MM-DD HH:MM:SS\"  (required)
        :param str time_end_t0: End date for the start-of-period dataset. Format: \"YYYY-MM-DD HH:MM:SS\"  (required)
        :param str time_start_t1: Start date for the end-of-period dataset. Format: \"YYYY-MM-DD HH:MM:SS\"  (required)
        :param str time_end_t1: End date for the end-of-period dataset. Format: \"YYYY-MM-DD HH:MM:SS\"  (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words.
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopicDeltaModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'time_start_t0', 'time_end_t0', 'time_start_t1', 'time_end_t1', 'query', 'custom_stop_words', 'num_topics', 'num_keywords', 'metadata_selection', 'excluded_docs']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_topic_delta_api" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_topic_delta_api`")  # noqa: E501
        # verify the required parameter 'time_start_t0' is set
        if ('time_start_t0' not in params or
                params['time_start_t0'] is None):
            raise ValueError("Missing the required parameter `time_start_t0` when calling `get_topic_delta_api`")  # noqa: E501
        # verify the required parameter 'time_end_t0' is set
        if ('time_end_t0' not in params or
                params['time_end_t0'] is None):
            raise ValueError("Missing the required parameter `time_end_t0` when calling `get_topic_delta_api`")  # noqa: E501
        # verify the required parameter 'time_start_t1' is set
        if ('time_start_t1' not in params or
                params['time_start_t1'] is None):
            raise ValueError("Missing the required parameter `time_start_t1` when calling `get_topic_delta_api`")  # noqa: E501
        # verify the required parameter 'time_end_t1' is set
        if ('time_end_t1' not in params or
                params['time_end_t1'] is None):
            raise ValueError("Missing the required parameter `time_end_t1` when calling `get_topic_delta_api`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501
        if 'custom_stop_words' in params:
            query_params.append(('custom_stop_words', params['custom_stop_words']))  # noqa: E501
        if 'num_topics' in params:
            query_params.append(('num_topics', params['num_topics']))  # noqa: E501
        if 'num_keywords' in params:
            query_params.append(('num_keywords', params['num_keywords']))  # noqa: E501
        if 'metadata_selection' in params:
            query_params.append(('metadata_selection', params['metadata_selection']))  # noqa: E501
        if 'time_start_t0' in params:
            query_params.append(('time_start_t0', params['time_start_t0']))  # noqa: E501
        if 'time_end_t0' in params:
            query_params.append(('time_end_t0', params['time_end_t0']))  # noqa: E501
        if 'time_start_t1' in params:
            query_params.append(('time_start_t1', params['time_start_t1']))  # noqa: E501
        if 'time_end_t1' in params:
            query_params.append(('time_end_t1', params['time_end_t1']))  # noqa: E501
        if 'excluded_docs' in params:
            query_params.append(('excluded_docs', params['excluded_docs']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/topics/topic_delta', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TopicDeltaModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_topic_historical_analysis_api(self, dataset, time_period, update_period, **kwargs):  # noqa: E501
        """get_topic_historical_analysis_api  # noqa: E501

        Get a historical analysis of topics extracted from a dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_historical_analysis_api(dataset, time_period, update_period, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str time_period: Time period selection (required)
        :param str update_period: Frequency at which the historical anlaysis is performed (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param int inc_step: Number of increments of the udpate period in between two historical computations.
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopiHistModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_topic_historical_analysis_api_with_http_info(dataset, time_period, update_period, **kwargs)  # noqa: E501
        else:
            (data) = self.get_topic_historical_analysis_api_with_http_info(dataset, time_period, update_period, **kwargs)  # noqa: E501
            return data

    def get_topic_historical_analysis_api_with_http_info(self, dataset, time_period, update_period, **kwargs):  # noqa: E501
        """get_topic_historical_analysis_api  # noqa: E501

        Get a historical analysis of topics extracted from a dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_historical_analysis_api_with_http_info(dataset, time_period, update_period, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str time_period: Time period selection (required)
        :param str update_period: Frequency at which the historical anlaysis is performed (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param int inc_step: Number of increments of the udpate period in between two historical computations.
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopiHistModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'time_period', 'update_period', 'query', 'custom_stop_words', 'num_topics', 'num_keywords', 'metadata_selection', 'inc_step', 'excluded_docs']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_topic_historical_analysis_api" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_topic_historical_analysis_api`")  # noqa: E501
        # verify the required parameter 'time_period' is set
        if ('time_period' not in params or
                params['time_period'] is None):
            raise ValueError("Missing the required parameter `time_period` when calling `get_topic_historical_analysis_api`")  # noqa: E501
        # verify the required parameter 'update_period' is set
        if ('update_period' not in params or
                params['update_period'] is None):
            raise ValueError("Missing the required parameter `update_period` when calling `get_topic_historical_analysis_api`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501
        if 'custom_stop_words' in params:
            query_params.append(('custom_stop_words', params['custom_stop_words']))  # noqa: E501
        if 'num_topics' in params:
            query_params.append(('num_topics', params['num_topics']))  # noqa: E501
        if 'num_keywords' in params:
            query_params.append(('num_keywords', params['num_keywords']))  # noqa: E501
        if 'metadata_selection' in params:
            query_params.append(('metadata_selection', params['metadata_selection']))  # noqa: E501
        if 'time_period' in params:
            query_params.append(('time_period', params['time_period']))  # noqa: E501
        if 'update_period' in params:
            query_params.append(('update_period', params['update_period']))  # noqa: E501
        if 'inc_step' in params:
            query_params.append(('inc_step', params['inc_step']))  # noqa: E501
        if 'excluded_docs' in params:
            query_params.append(('excluded_docs', params['excluded_docs']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/topics/topic_historical', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TopiHistModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_topic_sentiment_api(self, dataset, **kwargs):  # noqa: E501
        """get_topic_sentiment_api  # noqa: E501

        Get topic sentiment for topics extracted from a given dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_sentiment_api(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopicSentimentModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_topic_sentiment_api_with_http_info(dataset, **kwargs)  # noqa: E501
        else:
            (data) = self.get_topic_sentiment_api_with_http_info(dataset, **kwargs)  # noqa: E501
            return data

    def get_topic_sentiment_api_with_http_info(self, dataset, **kwargs):  # noqa: E501
        """get_topic_sentiment_api  # noqa: E501

        Get topic sentiment for topics extracted from a given dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_sentiment_api_with_http_info(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words
        :param int num_topics: Number of topics to be extracted from the dataset.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopicSentimentModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'query', 'custom_stop_words', 'num_topics', 'num_keywords', 'metadata_selection', 'time_period', 'excluded_docs']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_topic_sentiment_api" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_topic_sentiment_api`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501
        if 'custom_stop_words' in params:
            query_params.append(('custom_stop_words', params['custom_stop_words']))  # noqa: E501
        if 'num_topics' in params:
            query_params.append(('num_topics', params['num_topics']))  # noqa: E501
        if 'num_keywords' in params:
            query_params.append(('num_keywords', params['num_keywords']))  # noqa: E501
        if 'metadata_selection' in params:
            query_params.append(('metadata_selection', params['metadata_selection']))  # noqa: E501
        if 'time_period' in params:
            query_params.append(('time_period', params['time_period']))  # noqa: E501
        if 'excluded_docs' in params:
            query_params.append(('excluded_docs', params['excluded_docs']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/topics/topic_sentiment', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TopicSentimentModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_topic_summary_api(self, dataset, **kwargs):  # noqa: E501
        """get_topic_summary_api  # noqa: E501

        Get summaries of topics that have been extracted from a dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_summary_api(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words
        :param int num_topics: Number of topics to be extracted from the dataset and summarized.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :param int summary_length: The maximum number of bullet points a user wants to see in each topic summary.
        :param int context_amount: The number of sentences surrounding key summary sentences in the documents that they come from.
        :param int num_docs: The maximum number of key documents to use for summarization.
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopicSummaryModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_topic_summary_api_with_http_info(dataset, **kwargs)  # noqa: E501
        else:
            (data) = self.get_topic_summary_api_with_http_info(dataset, **kwargs)  # noqa: E501
            return data

    def get_topic_summary_api_with_http_info(self, dataset, **kwargs):  # noqa: E501
        """get_topic_summary_api  # noqa: E501

        Get summaries of topics that have been extracted from a dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_topic_summary_api_with_http_info(dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str dataset: Dataset name. (required)
        :param str query: Fulltext query, using mysql MATCH boolean query format. Example, (\"word1\" OR \"word2\") AND (\"word3\" OR \"word4\")
        :param str custom_stop_words: List of stop words
        :param int num_topics: Number of topics to be extracted from the dataset and summarized.
        :param int num_keywords: Number of keywords per topic that is extracted from the dataset.
        :param str metadata_selection: json object of {\"metadata_field\":[\"selected_values\"]}
        :param str time_period: Time period selection
        :param int summary_length: The maximum number of bullet points a user wants to see in each topic summary.
        :param int context_amount: The number of sentences surrounding key summary sentences in the documents that they come from.
        :param int num_docs: The maximum number of key documents to use for summarization.
        :param str excluded_docs: List of document IDs that should be excluded from the analysis. Example, \"docid1, docid2, ..., docidN\" 
        :return: TopicSummaryModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['dataset', 'query', 'custom_stop_words', 'num_topics', 'num_keywords', 'metadata_selection', 'time_period', 'summary_length', 'context_amount', 'num_docs', 'excluded_docs']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_topic_summary_api" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `get_topic_summary_api`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501
        if 'query' in params:
            query_params.append(('query', params['query']))  # noqa: E501
        if 'custom_stop_words' in params:
            query_params.append(('custom_stop_words', params['custom_stop_words']))  # noqa: E501
        if 'num_topics' in params:
            query_params.append(('num_topics', params['num_topics']))  # noqa: E501
        if 'num_keywords' in params:
            query_params.append(('num_keywords', params['num_keywords']))  # noqa: E501
        if 'metadata_selection' in params:
            query_params.append(('metadata_selection', params['metadata_selection']))  # noqa: E501
        if 'time_period' in params:
            query_params.append(('time_period', params['time_period']))  # noqa: E501
        if 'summary_length' in params:
            query_params.append(('summary_length', params['summary_length']))  # noqa: E501
        if 'context_amount' in params:
            query_params.append(('context_amount', params['context_amount']))  # noqa: E501
        if 'num_docs' in params:
            query_params.append(('num_docs', params['num_docs']))  # noqa: E501
        if 'excluded_docs' in params:
            query_params.append(('excluded_docs', params['excluded_docs']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/topics/topic_summary', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TopicSummaryModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_user(self, user_email, password, **kwargs):  # noqa: E501
        """get_user  # noqa: E501

        Use this API to authenticate. If the password is correct, returns the user details, including the user's api key.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user(user_email, password, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user_email: Email of the user to authenticate.  (required)
        :param str password: Plaintext password of the user to authenticate.  (required)
        :return: UserModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_user_with_http_info(user_email, password, **kwargs)  # noqa: E501
        else:
            (data) = self.get_user_with_http_info(user_email, password, **kwargs)  # noqa: E501
            return data

    def get_user_with_http_info(self, user_email, password, **kwargs):  # noqa: E501
        """get_user  # noqa: E501

        Use this API to authenticate. If the password is correct, returns the user details, including the user's api key.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_user_with_http_info(user_email, password, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str user_email: Email of the user to authenticate.  (required)
        :param str password: Plaintext password of the user to authenticate.  (required)
        :return: UserModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['user_email', 'password']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'user_email' is set
        if ('user_email' not in params or
                params['user_email'] is None):
            raise ValueError("Missing the required parameter `user_email` when calling `get_user`")  # noqa: E501
        # verify the required parameter 'password' is set
        if ('password' not in params or
                params['password'] is None):
            raise ValueError("Missing the required parameter `password` when calling `get_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'user_email' in params:
            query_params.append(('user_email', params['user_email']))  # noqa: E501
        if 'password' in params:
            query_params.append(('password', params['password']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/users', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='UserModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_append_json_to_dataset(self, payload, **kwargs):  # noqa: E501
        """post_append_json_to_dataset  # noqa: E501

        Add a document to a dataset, in JSON form.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_append_json_to_dataset(payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Appendjsonparams payload: (required)
        :return: AppendjsonpostModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_append_json_to_dataset_with_http_info(payload, **kwargs)  # noqa: E501
        else:
            (data) = self.post_append_json_to_dataset_with_http_info(payload, **kwargs)  # noqa: E501
            return data

    def post_append_json_to_dataset_with_http_info(self, payload, **kwargs):  # noqa: E501
        """post_append_json_to_dataset  # noqa: E501

        Add a document to a dataset, in JSON form.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_append_json_to_dataset_with_http_info(payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Appendjsonparams payload: (required)
        :return: AppendjsonpostModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['payload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_append_json_to_dataset" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'payload' is set
        if ('payload' not in params or
                params['payload'] is None):
            raise ValueError("Missing the required parameter `payload` when calling `post_append_json_to_dataset`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'payload' in params:
            body_params = params['payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/datasets/append_json_to_dataset', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='AppendjsonpostModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_delete_dataset(self, payload, **kwargs):  # noqa: E501
        """post_delete_dataset  # noqa: E501

        Delete an existing dataset from the user storage.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_delete_dataset(payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Deletedatasetmodel payload: (required)
        :return: DeletepostModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_delete_dataset_with_http_info(payload, **kwargs)  # noqa: E501
        else:
            (data) = self.post_delete_dataset_with_http_info(payload, **kwargs)  # noqa: E501
            return data

    def post_delete_dataset_with_http_info(self, payload, **kwargs):  # noqa: E501
        """post_delete_dataset  # noqa: E501

        Delete an existing dataset from the user storage.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_delete_dataset_with_http_info(payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Deletedatasetmodel payload: (required)
        :return: DeletepostModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['payload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_delete_dataset" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'payload' is set
        if ('payload' not in params or
                params['payload'] is None):
            raise ValueError("Missing the required parameter `payload` when calling `post_delete_dataset`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'payload' in params:
            body_params = params['payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/datasets/delete_dataset', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DeletepostModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_delete_document(self, payload, **kwargs):  # noqa: E501
        """post_delete_document  # noqa: E501

        Delete a document from a dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_delete_document(payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Deletedocumentmodel payload: (required)
        :return: DeletedocumentpostModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_delete_document_with_http_info(payload, **kwargs)  # noqa: E501
        else:
            (data) = self.post_delete_document_with_http_info(payload, **kwargs)  # noqa: E501
            return data

    def post_delete_document_with_http_info(self, payload, **kwargs):  # noqa: E501
        """post_delete_document  # noqa: E501

        Delete a document from a dataset.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_delete_document_with_http_info(payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Deletedocumentmodel payload: (required)
        :return: DeletedocumentpostModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['payload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_delete_document" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'payload' is set
        if ('payload' not in params or
                params['payload'] is None):
            raise ValueError("Missing the required parameter `payload` when calling `post_delete_document`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'payload' in params:
            body_params = params['payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/datasets/delete_document', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='DeletedocumentpostModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_example_job(self, color, **kwargs):  # noqa: E501
        """post_example_job  # noqa: E501

        Start an example background job  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_example_job(color, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str color: A color (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_example_job_with_http_info(color, **kwargs)  # noqa: E501
        else:
            (data) = self.post_example_job_with_http_info(color, **kwargs)  # noqa: E501
            return data

    def post_example_job_with_http_info(self, color, **kwargs):  # noqa: E501
        """post_example_job  # noqa: E501

        Start an example background job  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_example_job_with_http_info(color, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str color: A color (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['color']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_example_job" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'color' is set
        if ('color' not in params or
                params['color'] is None):
            raise ValueError("Missing the required parameter `color` when calling `post_example_job`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'color' in params:
            query_params.append(('color', params['color']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['text/html'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/jobs/start_example_job', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_upload_file(self, file, dataset, **kwargs):  # noqa: E501
        """post_upload_file  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_upload_file(file, dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param file file: (required)
        :param str dataset: Destination dataset where the file will be inserted. (required)
        :param str metadata: Optional json containing additional document metadata. Eg: {\"time\":\"01/01/2001\",\"author\":\"me\"}
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_upload_file_with_http_info(file, dataset, **kwargs)  # noqa: E501
        else:
            (data) = self.post_upload_file_with_http_info(file, dataset, **kwargs)  # noqa: E501
            return data

    def post_upload_file_with_http_info(self, file, dataset, **kwargs):  # noqa: E501
        """post_upload_file  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_upload_file_with_http_info(file, dataset, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param file file: (required)
        :param str dataset: Destination dataset where the file will be inserted. (required)
        :param str metadata: Optional json containing additional document metadata. Eg: {\"time\":\"01/01/2001\",\"author\":\"me\"}
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['file', 'dataset', 'metadata']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_upload_file" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'file' is set
        if ('file' not in params or
                params['file'] is None):
            raise ValueError("Missing the required parameter `file` when calling `post_upload_file`")  # noqa: E501
        # verify the required parameter 'dataset' is set
        if ('dataset' not in params or
                params['dataset'] is None):
            raise ValueError("Missing the required parameter `dataset` when calling `post_upload_file`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'metadata' in params:
            query_params.append(('metadata', params['metadata']))  # noqa: E501
        if 'dataset' in params:
            query_params.append(('dataset', params['dataset']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}
        if 'file' in params:
            local_var_files['file'] = params['file']  # noqa: E501

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['multipart/form-data'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/datasets/upload_file', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_upload_url(self, payload, **kwargs):  # noqa: E501
        """post_upload_url  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_upload_url(payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param UploadURLModel payload: (required)
        :return: UploadurlpostModel
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_upload_url_with_http_info(payload, **kwargs)  # noqa: E501
        else:
            (data) = self.post_upload_url_with_http_info(payload, **kwargs)  # noqa: E501
            return data

    def post_upload_url_with_http_info(self, payload, **kwargs):  # noqa: E501
        """post_upload_url  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_upload_url_with_http_info(payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param UploadURLModel payload: (required)
        :return: UploadurlpostModel
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['payload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_upload_url" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'payload' is set
        if ('payload' not in params or
                params['payload'] is None):
            raise ValueError("Missing the required parameter `payload` when calling `post_upload_url`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'payload' in params:
            body_params = params['payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/datasets/import_file_from_url', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='UploadurlpostModel',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_user(self, payload, **kwargs):  # noqa: E501
        """post_user  # noqa: E501

        Use this API to register a new user. Email and password are required, all other fields optional.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_user(payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param User payload: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_user_with_http_info(payload, **kwargs)  # noqa: E501
        else:
            (data) = self.post_user_with_http_info(payload, **kwargs)  # noqa: E501
            return data

    def post_user_with_http_info(self, payload, **kwargs):  # noqa: E501
        """post_user  # noqa: E501

        Use this API to register a new user. Email and password are required, all other fields optional.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_user_with_http_info(payload, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param User payload: (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['payload']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_user" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'payload' is set
        if ('payload' not in params or
                params['payload'] is None):
            raise ValueError("Missing the required parameter `payload` when calling `post_user`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'payload' in params:
            body_params = params['payload']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apikey']  # noqa: E501

        return self.api_client.call_api(
            '/users', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
